<template>
    <div id="register">
        <el-form :model="form" label-width="120px">
            <el-form-item label="Login">
                <el-input v-model="form.login" />
            </el-form-item>
            <el-form-item label="Password">
                <el-input @input="handlePasswordChange" v-model="form.password" type="password"
                    placeholder="Please input password" show-password />
            </el-form-item>
            <div id="password-meter-wrapper">
                <el-progress :text-inside="true" :stroke-width="24" :percentage="passwordScore" :status="passwordStatus" />
            </div>
            <el-form-item label="Repeat Password">
                <el-input v-model="form.repeatPassword" type="password" placeholder="Please input your password again"
                    show-password />
            </el-form-item>
            <el-form-item>
                <el-button type="primary" @click="onSubmit">Create</el-button>
                <el-button>Cancel</el-button>
            </el-form-item>
        </el-form>
        <el-dialog v-model="dialogRegisterVisible" title="Message" width="45%" :before-close="handleClose">
            <span>You have been registered</span>
            <template #footer>
                <span class="dialog-footer">
                    <el-button type="primary" @click="dialogRegisterVisible = false">
                        OK
                    </el-button>
                </span>
            </template>
        </el-dialog>
    </div>
</template>
  
<script setup lang="ts">
import { reactive, ref } from 'vue';
import axios, { AxiosResponse } from 'axios';
import { useRouter } from 'vue-router';
import { ElNotification, ElMessageBox } from 'element-plus';
import useEmitter from '../composables/useEmitter';
import { scorePassword } from '../helpers';

const router = useRouter();
const emitter = useEmitter();
const form = reactive({
    login: '',
    password: '',
    repeatPassword: '',
});
const passwordScore = ref(0);
const passwordStatus = ref('exception');
const dialogRegisterVisible = ref(false);

const handlePasswordChange = () => {
    passwordScore.value = Math.ceil(scorePassword(form.password) * 5 / 4);

    if (passwordScore.value <= 50) {
        passwordStatus.value = 'exception';
    } else if (50 < passwordScore.value && passwordScore.value <= 70) {
        passwordStatus.value = 'warning';
    } else if (80 < passwordScore.value) {
        passwordStatus.value = 'success';
    }
};

const openWeakPassword = () => {
    ElNotification({
        title: 'Error',
        message: 'Password too weak',
        type: 'error',
    });
};

const openPasswordDiffer = () => {
    ElNotification({
        title: 'Error',
        message: 'Passwords do not match',
        type: 'error',
    });
};

const onSubmit = () => {
    let ok = true;

    if (passwordStatus.value !== 'success') {
        openWeakPassword();
        ok = false;
    }

    if (form.password !== form.repeatPassword) {
        openPasswordDiffer();
        ok = false;
    }

    if (ok) {
        registerUser();
    }
};

const registerUser = () => {
    axios
        // @ts-ignore
        .post(`${import.meta.env.VITE_HOST}:${import.meta.env.VITE_PORT}/api/v1/user`, {
            email: form.login,
            password: form.password,
        })
        .then(({ data }: AxiosResponse) => {
            if (data.status === 'OK') {
                dialogRegisterVisible.value = true;
                setTimeout(() => {
                    emitter.emit('homepage');
                    router.push('/');
                }, 3000);
            }
        })
        .catch((err) => {
            console.error(err.response.data.message);
            if (err.response.data.message === 'User with a given email already exists') {
                openUserExists();
            }
        });
};

const handleClose = (done: () => void) => {
    ElMessageBox.confirm('Are you sure to close this dialog?')
        .then(() => {
            done();
        })
        .catch(() => {
            // Handle cancellation
        });
};

const openUserExists = () => {
    ElNotification({
        title: 'Error',
        message: 'User already exists',
        type: 'error',
        position: 'bottom-right',
    });
};
</script>
  
<style scoped lang="scss">
#register {
    position: relative;
    top: 100px;

    #password-meter-wrapper {
        width: 80%;
        margin: 20px;
        position: relative;
        left: 105px;
    }
}
</style>
  